SCRIPT_DIR=$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )

CORE_SRC_DIR=$SCRIPT_DIR/../src/base/core

g++ $SCRIPT_DIR/test_runner.cpp \
    $CORE_SRC_DIR/system/process/CommandLineArgs.cpp \
    $CORE_SRC_DIR/base_types/Error.cpp \
    $CORE_SRC_DIR/base_types/Index.cpp \
    $CORE_SRC_DIR/base_types/Char.cpp \
    $CORE_SRC_DIR/data_structures/String.cpp \
    $CORE_SRC_DIR/filesystem/File.cpp \
    $CORE_SRC_DIR/filesystem/FileSystemPath.cpp \
    $CORE_SRC_DIR/logging/Logger.cpp \
    $CORE_SRC_DIR/logging/ConsoleLogger.cpp \
    $CORE_SRC_DIR/serialization/yaml/YamlDocument.cpp \
    $CORE_SRC_DIR/serialization/yaml/YamlDocuments.cpp \
    $CORE_SRC_DIR/serialization/yaml/YamlParser.cpp \
    $CORE_SRC_DIR/streams/Stream.cpp \
    $CORE_SRC_DIR/streams/StringStream.cpp \
    $CORE_SRC_DIR/time/Time.cpp \
    $SCRIPT_DIR/test_utils/TestCaseRunner.cpp \
    $SCRIPT_DIR/core/TestFileSystemPath.cpp \
    $SCRIPT_DIR/core/TestString.cpp \
    $SCRIPT_DIR/core/TestVector.cpp \
    $SCRIPT_DIR/core/TestYamlParser.cpp \
    -o test_runner -g \
        -I$SCRIPT_DIR/test_utils \
        -I$CORE_SRC_DIR \
        -I$CORE_SRC_DIR/encoding \
        -I$CORE_SRC_DIR/logging \
        -I$CORE_SRC_DIR/data_structures \
        -I$CORE_SRC_DIR/base_types \
        -I$CORE_SRC_DIR/memory \
        -I$CORE_SRC_DIR/system/process \
        -I$CORE_SRC_DIR/streams \
        -I$CORE_SRC_DIR/serialization/yaml \
        -I$CORE_SRC_DIR/time \
        -I$CORE_SRC_DIR/filesystem