#include "Bits.h"
#include "BufferBitStream.h"

#include "TestFramework.h"

#include <iostream>

TEST_CASE(TestReadBitStream, "core")
{
    Vector<String> bytes{
        "11101101",
        "01011101",
        "00001001",
        "01111111"};

    BufferBitStream stream;
    for(const auto& byte : bytes)
    {
        stream.writeByte(Bits::getFromString(byte));
    }

    unsigned char buffer{0} ;
    auto valid = stream.readNextNBits(1, buffer);
    //std::cout << "Slice0 is " << Bits::toString(buffer) << std::endl;

    valid = stream.readNextNBits(2, buffer);
    //std::cout << "Slice1 is " << Bits::toString(buffer) << std::endl;

    valid = stream.readNextNBits(5, buffer);
    //std::cout << "Slice2 is " << Bits::toString(buffer) << std::endl;

    valid = stream.readNextNBits(5, buffer);
    //std::cout << "Slice3 is " << Bits::toString(buffer) << std::endl;

    valid = stream.readNextNBits(4, buffer);
    //std::cout << "Slice3 is " << Bits::toString(buffer) << " and int " << static_cast<int>(buffer) << std::endl;

    valid = stream.readNextNBits(3, buffer);
    //std::cout << "Slice3 is " << Bits::toString(buffer) << std::endl;
    REQUIRE(valid);
}

TEST_CASE(TestWritingBitStream, "core")
{
    BufferBitStream stream;

    stream.writeByte(Bits::getFromString("01100000"));

    auto bits0 = Bits::getFromString("00000111");
    stream.writeNBits(bits0, 3);

    stream.writeByte(Bits::getFromString("11110000"));

    auto bits1 = Bits::getFromString("01001101");
    stream.writeNBits(bits1, 7);

    stream.writeByte(Bits::getFromString("11110000"));

    auto bits2 = Bits::getFromString("00000001");
    stream.writeNBits(bits2, 1);

    stream.flushRemainingBits();

    stream.resetOffsets();

    auto byte0 = Bits::toString(*stream.readNextByte());
    auto byte1 = Bits::toString(*stream.readNextByte());
    auto byte2 = Bits::toString(*stream.readNextByte());
    auto byte3 = Bits::toString(*stream.readNextByte());
    auto byte4 = Bits::toString(*stream.readNextByte());

    //std::cout << "Got bytes 0 " << byte0 << std::endl;
    //std::cout << "Got bytes 1 " << byte1 << std::endl;
    //std::cout << "Got bytes 2 " << byte2 << std::endl;
    //std::cout << "Got bytes 3 " << byte3 << std::endl;
    //std::cout << "Got bytes 4 " << byte4 << std::endl;
}
